﻿Public Class frmOracle

    Private EntitaPerTabellaConChiaveIdentity As TBLCONCHIAVEIDENTITY
    Private EntitaPerTabellaConChiaveComposta As TBLCONCHIAVECOMPOSTA
    Private EntitaPerTabellaSenzaChiave As TBLSENZACHIAVE

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        ' Faccio la insert di un nuovo record

        EntitaPerTabellaConChiaveIdentity = New TBLCONCHIAVEIDENTITY
        Dim MirandaProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveIdentity)

        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        MirandaProxy.DataLink = SqlServer

        ' Specifico i valori
        With EntitaPerTabellaConChiaveIdentity
            .Cambio = 1.56
            .Nome = "Test"
            .Valuta = "PPP"
        End With

        Dim Res As Object = MirandaProxy.Insert()

        ' A questo punto in IDValuta ci dovrà essere l'ID assegnato da Sql Server (è una colonna Identity)
        Debug.Print(EntitaPerTabellaConChiaveIdentity.IDValuta)
    End Sub

    Private Sub Button8_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button8.Click
        EntitaPerTabellaConChiaveIdentity = New TBLCONCHIAVEIDENTITY ' Entita che descrive la tabella tblConChiaveIdentity
        Dim MirandaProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveIdentity) ' Definisco il manager della entità sopra


        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString) ' Questo è dove verranno eseguiti i comandi sql
        MirandaProxy.DataLink = SqlServer ' Assegno al Manager il DB a cui inviare i comandi

        ' Carico UN SOLO record fornendo la chiave
        MirandaProxy.Load(New Pezzoli.Data.Miranda.EntityKey(New Pezzoli.Data.Miranda.EntityKeyItem("VALUTA", "PPP")))

        ' Carico un altro record che va al posto di quello di prima
        'MirandaProxy.Load(New Pezzoli.Data.Miranda.EntityKey(New Pezzoli.Data.Miranda.EntityKeyItem("VALUTA", "CHF")))
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        EntitaPerTabellaConChiaveIdentity = New TBLCONCHIAVEIDENTITY

        Dim MirandaProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveIdentity)

        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        MirandaProxy.DataLink = SqlServer

        ' Carico il record da modificare
        MirandaProxy.Load(New Pezzoli.Data.Miranda.EntityKey(New Pezzoli.Data.Miranda.EntityKeyItem("VALUTA", "PPP"))) ' Where Valuta = 'PPP'
        EntitaPerTabellaConChiaveIdentity.CAMBIO = 1.1

        ' Aggiorno il record sul DB
        Dim Res As Object = MirandaProxy.Updates()
    End Sub

    Private Sub cmdDelete_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDelete.Click
        EntitaPerTabellaConChiaveIdentity = New TBLCONCHIAVEIDENTITY
        Dim Valute As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveIdentity)

        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        Valute.DataLink = SqlServer


        Valute.Load(New Pezzoli.Data.Miranda.EntityKey(New Pezzoli.Data.Miranda.EntityKeyItem(TBLCONCHIAVEIDENTITY.LinkedProperties.VALUTA.ToString, "PPP")))

        Dim Res As Object = Valute.Delete
    End Sub

    Private Sub cmdInsertCompositeKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdInsertCompositeKey.Click
        ' Faccio la insert di un nuovo record

        EntitaPerTabellaConChiaveComposta = New TBLCONCHIAVECOMPOSTA
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveComposta)

        ' uso il reader per caricare una entità
        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        With EntitaPerTabellaConChiaveComposta
            .DESCRIZIONE = "X""X'X"
            .IDCONDIZIONE = 1
            .IDCONTO = 99
            .IDTIPO = 1
            .VALIDOAL = New Date(2012, 12, 12)
            .VALORE = "A"
        End With

        Dim Res As Object = CondizioneProxy.Insert()
    End Sub

    Private Sub Button9_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button9.Click
        EntitaPerTabellaConChiaveComposta = New TBLCONCHIAVECOMPOSTA
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveComposta)

        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        ' Costruisco la chiave composta di ricerca
        'Dim Key As New Pezzoli.Data.Miranda.EntityKey()
        'Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("IDContoCorrente", 99))
        'Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("Descrizione", "X""X'X"))
        ' oppure uso direttamente i nomi delle proprietà della entità, NON i nomi dei campi della tabella
        CondizioneProxy.Load("IDCONTO = 99 And DESCRIZIONE='X""X'X'")
    End Sub

    Private Sub cmdUpdateCompositeKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdUpdateCompositeKey.Click
        ' Faccio la update di un record esistente

        EntitaPerTabellaConChiaveComposta = New TBLCONCHIAVECOMPOSTA
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveComposta)

        ' uso il reader per caricare una entità
        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        ' Costruisco la chiave composta di ricerca
        Dim Key As New Pezzoli.Data.Miranda.EntityKey()
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("IDCONTO", 99))
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("DESCRIZIONE", "X""X'X"))
        CondizioneProxy.Load(Key)

        ' Modifico l'entità
        EntitaPerTabellaConChiaveComposta.DESCRIZIONE = "TES'T"
        EntitaPerTabellaConChiaveComposta.VALORE = "B"
        EntitaPerTabellaConChiaveComposta.VIRGOLADOPPIA = 10.6
        EntitaPerTabellaConChiaveComposta.REALE = 6.9999
        'EntitaPerTabellaConChiaveComposta.VALIDOAL = New Date(2010, 12, 31) ' Dà errore perchè fa parte della chiave
        'Condizione.IDContoCorrente = 999 ' Non deve permettemelo, perchè fa parte di una entità caricata e la chiave è fissa. Diverso sarebbe se il record fosse nuovo

        Dim Res As Object = CondizioneProxy.Updates
    End Sub

    Private Sub cmdDeleteCompositeKey_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles cmdDeleteCompositeKey.Click
        ' Faccio la delete di un nuovo record

        EntitaPerTabellaConChiaveComposta = New TBLCONCHIAVECOMPOSTA
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaConChiaveComposta)

        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        ' Costruisco la chiave composta di ricerca
        Dim Key As New Pezzoli.Data.Miranda.EntityKey()
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("IDCONTO", 99))
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("DESCRIZIONE", "TES'T"))
        CondizioneProxy.Load(Key)

        Dim Res As Object = CondizioneProxy.Delete
    End Sub

    Private Sub Button5_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button5.Click
        ' Faccio la insert di un nuovo record

        EntitaPerTabellaSenzaChiave = New TBLSENZACHIAVE
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaSenzaChiave)

        ' uso il reader per caricare una entità
        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        With EntitaPerTabellaSenzaChiave
            .BOOLEANO = True
            .TESTOVARIABILE = "Bo"
            .REALE = 10.2
            .VIRGOLADOPPIA = 10.2
            .DATAPICCOLA = Date.Now
            .INTERO = 5600
        End With

        'If EntitaPerTabellaSenzaChiave.HasChanges(tblSenzaChiave.LinkedProperties.Reale) Then
        '    Debug.Write("a")
        'End If

        'EntitaPerTabellaSenzaChiave.CancelEdit()

        Dim Res As Object = CondizioneProxy.Insert()
    End Sub

    Private Sub Button10_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button10.Click
        EntitaPerTabellaSenzaChiave = New TBLSENZACHIAVE
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaSenzaChiave)

        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        ' Costruisco la chiave composta di ricerca
        'Dim Key As New Pezzoli.Data.Miranda.EntityKey()
        'Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("IDContoCorrente", 99))
        'Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("Descrizione", "X""X'X"))
        ' oppure uso direttamente i nomi delle proprietà della entità, NON i nomi dei campi della tabella
        CondizioneProxy.Load("INTERO = 5600 And BOOLEANO = True")
    End Sub

    Private Sub Button6_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button6.Click
        ' Faccio la update di un record esistente

        EntitaPerTabellaSenzaChiave = New TBLSENZACHIAVE
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaSenzaChiave)

        ' uso il reader per caricare una entità
        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        ' Costruisco la chiave composta di ricerca
        Dim Key As New Pezzoli.Data.Miranda.EntityKey()
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem(TBLSENZACHIAVE.LinkedProperties.BOOLEANO.ToString, True))
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem(TBLSENZACHIAVE.LinkedProperties.TESTOVARIABILE.ToString, "Bo"))
        CondizioneProxy.Load(Key)

        'EntitaPerTabellaSenzaChiave.DataPiccola = Date.Now
        EntitaPerTabellaSenzaChiave.BeginEdit()
        EntitaPerTabellaSenzaChiave.TESTOVARIABILE = "Bi"
        EntitaPerTabellaSenzaChiave.BOOLEANO = False
        EntitaPerTabellaSenzaChiave.REALE = 5
        EntitaPerTabellaSenzaChiave.DATAPICCOLA = Date.Now
        'EntitaPerTabellaSenzaChiave.CancelEdit(tblSenzaChiave.LinkedProperties.DataPiccola)
        EntitaPerTabellaSenzaChiave.EndEdit()

        Dim Res As Object = CondizioneProxy.Updates
    End Sub

    Private Sub Button7_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button7.Click
        ' Faccio la delete di un record

        EntitaPerTabellaSenzaChiave = New TBLSENZACHIAVE
        Dim CondizioneProxy As New Pezzoli.Data.Miranda.Proxy(EntitaPerTabellaSenzaChiave)

        ' uso il reader per caricare una entità
        Dim SqlServer As New Pezzoli.Data.Miranda.OracleClient.OracleServerDataLink(My.Settings.ConnectionString)
        CondizioneProxy.DataLink = SqlServer

        ' Costruisco la chiave composta di ricerca
        Dim Key As New Pezzoli.Data.Miranda.EntityKey()
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("BOOLEANO", False))
        Key.Add(New Pezzoli.Data.Miranda.EntityKeyItem("TESTOVARIABILE", "Bi"))

        If CondizioneProxy.Load(Key) Then
            Dim Res As Object = CondizioneProxy.Delete
        End If
    End Sub
End Class